> For the complete documentation index, see [llms.txt](https://docs.chainrpc.io/chainrpc/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.chainrpc.io/chainrpc/networks/ethereum/json-rpc-methods/filter-methods/eth_getfilterlogs.md).

# eth\_getFilterLogs

Returns an array of all logs matching filter with given id.

### REQUEST PARAMS

* `FILTER OBJECT`
  * `fromBlock`*\[optional, default: "latest"]* hexadecimal block number, or "latest" for the last mined block. The "pending" option is not currently supported.
  * `toBlock`*\[optional, default: "latest"]* hexadecimal block number, or "latest" for the last mined block.
  * `address`: *\[optional]* (20 Bytes) Contract address or a list of addresses from which logs should originate.
  * `topics`: *\[optional]* Array of 32 Bytes DATA topics. Topics are order-dependent. Each topic can also be an array of DATA with "or" options.
  * blockhash: *\[optional]* With the addition of EIP-234, blockHash restricts the logs returned to the single block with the 32-byte hash blockHash. Using blockHash is equivalent to fromBlock = toBlock = the block number with hash blockHash. If blockHash is present in the filter criteria, then neither fromBlock nor toBlock are allowed.

#### EXAMPLE

```bash
## JSON-RPC over HTTPS POST
## Replace YOUR-API-KEY with an API key from your chainRPC Dashboard
## You can also replace mainnet with a different supported network
curl https://eth.chainrpc.io/v3/YOUR-API-KEY \
    -X POST \
    -H "Content-Type: application/json" \
    -d '{"jsonrpc":"2.0","method":"eth_getFilterLogs","params":["0x10ff0bfbedb01f0dbd4106d14eb719ec38b6eb5b821c"],"id":1}'

## JSON-RPC over WSS
## Replace YOUR-API-KEY with an API key from your chainRPC Dashboard
## You can also replace mainnet with a different supported network
wscat -c wss://eth.chainrpc.io/v3/YOUR-API-KEY
>{"jsonrpc":"2.0","method":"eth_getFilterLogs","params":["0x10ff0bfbedb01f0dbd4106d14eb719ec38b6eb5b821c"],"id":1}
```

### RESPONSE

#### RESULT FIELDS

* `LOG OBJECT ARRAY` - Array of log objects, or an empty array if nothing has changed since last poll.
  * logs are objects with following params:
* `removed`: true when the log was removed, due to a chain reorganization. false if its a valid log.
* `logIndex`: hexadecimal of the log index position in the block. null when its pending log.
* `transactionIndex`: hexadecimal of the transactions index position log was created from. null when its pending log.
* `transactionHash`: 32 Bytes - hash of the transactions this log was created from. null when its pending log.
* `blockHash`: 32 Bytes - hash of the block where this log was in. null when its pending. null when its pending log.
* `blockNumber`: the block number where this log was in. null when its pending. null when its pending log.
* `address`: 20 Bytes - address from which this log originated.
* `data`: DATA - contains the non-indexed arguments of the log.
* `topics`: Array of DATA - Array of 0 to 4 32 Bytes DATA of indexed log arguments. (In solidity: The first topic is the hash of the signature of the event (e.g. Deposit(address,bytes32,uint256)), except you declared the event with the anonymous specifier.)

#### BODY

```json
{
    "jsonrpc": "2.0",
    "id": 73,
    "result": [{
        "address": "0xb5a5f22694352c15b00323844ad545abb2b11028",
        "blockHash": "0x99e8663c7b6d8bba3c7627a17d774238eae3e793dee30008debb2699666657de",
        "blockNumber": "0x5d12ab",
        "data": "0x0000000000000000000000000000000000000000000000a247d7a2955b61d000",
        "logIndex": "0x0",
        "removed": false,
        "topics": ["0xddf252ad1be2c89b69c2b068fc378daa952ba7f163c4a11628f55a4df523b3ef", "0x000000000000000000000000bdc0afe57b8e9468aa95396da2ab2063e595f37e", "0x0000000000000000000000007503e090dc2b64a88f034fb45e247cbd82b8741e"],
        "transactionHash": "0xa74c2432c9cf7dbb875a385a2411fd8f13ca9ec12216864b1a1ead3c99de99cd",
        "transactionIndex": "0x3"
    }, {
        "address": "0xe38165c9f6deb144afc9c32c206b024817e1496d",
        "blockHash": "0x99e8663c7b6d8bba3c7627a17d774238eae3e793dee30008debb2699666657de",
        "blockNumber": "0x5d12ab",
        "data": "0x0000000000000000000000000000000000000000000000000000000025c6b720",
        "logIndex": "0x3",
        "removed": false,
        "topics": ["0xddf252ad1be2c89b69c2b068fc378daa952ba7f163c4a11628f55a4df523b3ef", "0x00000000000000000000000080e73e47173b2d00b531bf83bc39e710157125c3", "0x0000000000000000000000008f6cc93795969e5bbbf07c66dfee7d41ad24f1ef"],
        "transactionHash": "0x9e8f1cb1facb9a11a1cf947634053a0b2d557399f926b12127aa10497a2f0153",
        "transactionIndex": "0x5"
    }
}
```
